(drawthurm "Loading C64 module" 4 "=")

; set your drive and user number for hi-tech c here
(setq user "")
(setq drive "")

; how linux defines a newline
(setq cr (chr 10))  

; dependencies utility
(defun copy (df fd fill)
	(let
		(
			(l)
			(name)
		)
		(setq l 1)
		(gc)
		(while (/= l 0)
			(setq name (readline df))
			(if (= name nil) 
				(setq l 0)
				(princ (strcat " " (strcat name ".obj")) fd)
			)
			(princ fill)
		)
	)
	(gc)
)

(princ "#")

; Linux "Makefile" extension
(setq ext ".cc65mkf")

; all rule
(defun all (dr un x dd fp)
	(princ "SYS = c64" fp)
	(princ cr fp)
	(princ "CRT0 = $(SYS).o" fp)
	(princ cr fp)
	(princ "CLIB = optiml65-$(SYS).lib $(SYS).lib" fp)
	(princ cr fp)
	(princ "CFLAGS = -O -t $(SYS) --standard c89" fp)
	(princ cr fp)
	(princ "LDFLAGS = -t $(SYS)" fp)
	(princ cr fp)
	(princ "CC = cc65" fp)
	(princ cr fp)
	(princ "AS = ca65" fp)
	(princ cr fp)
	(princ "LD = ld65" fp)
	(princ cr fp)
	(princ "AR = ar65" fp)
	(princ cr fp)
	(princ "OPT = optiml65" fp)
	(princ cr fp)
	(princ cr fp)
	(princ "all:\t" fp)
	(princ x fp)
	(princ cr fp)
	(princ cr fp)
)

; make clean routine
(defun clean (dr un x l pf fp)
	(princ "clean:" fp)
	(princ cr fp)
	(princ "\trm -f *~ *.bak *.BAK core *.obj " fp)
	(princ x fp)
	(princ " " fp)
	(princ l fp)
	(princ ".lib" fp)
	(copy pf fp "-")
	(princ cr fp)
	(princ cr fp)
)

; .c.o rules/dependencies
(defun ctooh (dr un x fp)
	(princ x fp)
	(princ ".obj:\t" fp)
	(princ x fp)
	(princ ".c" fp)
	(princ cr fp)
	(princ "\t$(CC) $(CFLAGS) -o " fp)
	(princ x fp)
	(princ ".n " fp)
	(princ x fp)
	(princ ".c" fp)
	(princ cr fp)
	(princ "\tcat " fp)
	(princ x fp)
	(princ ".n | $(OPT) > " fp)
	(princ x fp)
	(princ ".s" fp)
	(princ cr fp)
	(princ "\t$(AS) " fp)
	(princ x fp)
	(princ ".s" fp)
	(princ cr fp)
	(princ "\trm " fp)
	(princ x fp)
	(princ ".[ns]" fp)
	(princ cr fp)
	(princ "\tmv " fp)
	(princ x fp)
	(princ ".o " fp)
	(princ x fp)
	(princ ".obj" fp)
	(princ cr fp)
	(princ cr fp)
	(gc)
)

(princ "#")

; ar rule
(defun ar (un dr pf df fo)
		(princ fo pf)
		(princ "OBJS =" pf)
		(copy df pf "#")
		(princ cr pf)
		(princ cr pf)
		(princ fo pf)
		(princ ".lib:\t$(" pf)
		(princ fo pf)
		(princ "OBJS)" pf)
		(princ cr pf)
		(princ "\t$(AR) a " pf)
		(princ fo pf)
		(princ ".lib $(" pf)
		(princ fo pf)
		(princ "OBJS)" pf)
		(princ cr pf)
		(princ cr pf)
)

(princ "#")

; link rule
(defun link (un dr fp fn fo fl)
		(princ fn pf)
		(princ ":\t" pf)
		(princ fl pf)
		(princ ".lib" pf)
		(princ cr pf)
		(princ "\t$(LD) $(LDFLAGS) -o " pf)
		(princ fn pf)
		(princ " $(CRT0) " pf)
		(princ fn pf)
		(princ ".obj " pf)
		(princ fl pf)
		(princ ".lib $(CLIB)" pf)
		(princ cr pf)
		(princ cr pf)
)

(princ "#\n")
(gc)
