(drawthurm "Loading Linux module" 4 "=")

; set your drive and user number for hi-tech c here
(setq user "")
(setq drive "")

; how linux defines a newline
(setq cr (chr 10))  

; dependencies utility
(defun copy (df fd fill)
	(let
		(
			(l)
			(name)
		)
		(setq l 1)
		(gc)
		(while (/= l 0)
			(setq name (readline df))
			(if (= name nil) 
				(setq l 0)
				(princ (strcat " " (strcat name ".o")) fd)
			)
			(princ fill)
		)
	)
	(gc)
)

(princ "#")

; Linux "Makefile" extension
(setq ext ".gmk")

; all rule
(defun all (dr un x dd fp)
	(princ "CC = gcc" fp)
	(princ cr fp)
	(princ "LD = gcc" fp)
	(princ cr fp)
	(princ cr fp)
	(princ "all:\t" fp)
	(princ x fp)
	(princ cr fp)
	(princ cr fp)
)

; make clean routine
(defun clean (dr un x l pf fp)
	(princ "clean:" fp)
	(princ cr fp)
	(princ "\trm -f *~ *.bak *.BAK core " fp)
	(princ x fp)
	(princ " " fp)
	(princ l fp)
	(princ ".a" fp)
	(copy pf fp "-")
	(princ cr fp)
	(princ cr fp)
)

; .c.o rules/dependencies
(defun ctooh (dr un x fp)
	(princ x fp)
	(princ ".o:\t" fp)
	(princ x fp)
	(princ ".c" fp)
	(princ cr fp)
	(princ "\t$(CC) -g -O2 -Wall -pedantic -o " fp)
	(princ x fp)
	(princ ".o -c " fp)
	(princ x fp)
	(princ ".c" fp)
	(princ cr fp)
	(princ cr fp)
	(gc)
)

(princ "#")

; ar rule
(defun ar (un dr pf df fo)
		(princ fo pf)
		(princ "OBJS =" pf)
		(copy df pf "#")
		(princ cr pf)
		(princ cr pf)
		(princ fo pf)
		(princ ".a:\t$(" pf)
		(princ fo pf)
		(princ "OBJS)" pf)
		(princ cr pf)
		(princ "\tar rcs " pf)
		(princ fo pf)
		(princ ".a $(" pf)
		(princ fo pf)
		(princ "OBJS)" pf)
		(princ cr pf)
		(princ cr pf)
)

(princ "#")

; link rule
(defun link (un dr fp fn fo fl)
		(princ fn pf)
		(princ ":\t" pf)
		(princ fl pf)
		(princ ".a" pf)
		(princ cr pf)
		(princ "\t$(LD) -o " pf)
		(princ fn pf)
		(princ " " pf)
		(princ fl pf)
		(princ ".a" pf)
		(princ cr pf)
		(princ cr pf)
)

(princ "#\n")
(gc)
