;
; strings.lsp (c)2003 Grafixoft (a at oo dot ms)
;
; Handy string functions in lisp for parsing text
;

(drawthurm "Loading strings library" 6 "=")


;
; find first occurance of a string within a string 
; return start position, or length if not found
;
(defun strstr (s tt)
	(let	(
			(l 1)
			(sl (strlen s))
			(good 0)
			(ttt tt)
			(x)
		)
		(while (/= (strlen ttt) 0) 
			(setq x (substr ttt 1 sl))
			(setq l (+ 1 l))
			(if (= s x)
				(progn
					(setq l (- l 1)) 
					(setq ttt "") 
					(setq good 1)
				)
			)
			(setq ttt (substr ttt 2))
		)
		(if (= good 0)
				(setq l 0)
		)
		(setq good l)
	)
)

(princ "#")


;
; find the nth occurance of a string
; 0 indicates too far or none otherwise the offset
;
(defun strnth (x s tt)
	(let	(
			(y (strlen s))
			(ttt tt)
			(d (strlen s))
			(l x)
			(p)

		)

		(if (/= l 0)
			; yes
			(progn
				(setq d 1)
				(while (/= 0 l)
					(setq l (- l 1))
					(setq p (strstr s ttt))
					(setq ttt (substr ttt (+ p y)))
					(setq d (+ d p y))
					(setq d (- d 1)) 
					(if (= p 0)
						(progn
							(setq l 0)
							(setq d y)
						)
					)
				)
			)
		)
		(setq l (- d y))
	)
)

(princ "#")

;
; return string chopped, before, but not including located string number X
; return entire string if not found
;
(defun strbfr (x s tt)
	(let	(
		(y (strnth x s tt))
		(l)
		(ttt tt)
		)
		(setq l y)
		(if (/= l 0)
			(setq ttt (substr tt 1 (- y 1)))
		)
		(setq l ttt)
	)
)

(princ "#")

;
; return string chopped, after, but not including located string number X
; return entire string if not found
;
(defun straft (x s tt)
	(let	(
			(y (strnth x s tt))
			(l)
			(ttt tt)
		)
		(setq l y)
		(if (/= l 0)
			(setq ttt (substr tt (+ y (strlen s))))
		)
		(setq l ttt)
	)
)

(princ "#")

;
; replace occurance X of string within a string with a string
; returns (possibly) modified string
;
(defun strrepl (x s tt n)
	(let	(
			(y (strnth x s tt))
			(a)
			(ttt tt)

		)
		(if (/= y 0)
			; yes
			(progn
				(setq a (strcat (substr tt 1 (- y 1)) n))
				(setq ttt (strcat a (substr tt (+ y (strlen s)))))
			)
		)
		(setq a ttt)
	)
)

(princ "#")

;
; count how many times a string occurs within a string
;
(defun strcnt (s tt)
	(let	(
			(good 1)
			(q)
		)
		(while (/= 0 (strnth good s tt))
			(setq good (+ good 1))
		)
		(setq q (- good 1))
	)
)

(princ "#\n")

;
; tests of the above functions
;

; (princ "location of second 'e' :")
; (print (strnth 2 "e" 	"the quick brown fox jumpped over the lazy dogs"))
; (princ "total occurances of 'e' :")
; (print (strcnt "e" 	"the quick brown fox jumpped over the lazy dogs"))
; (print "0000000001111111111222222222333333333334444444")
; (print "1234567890123456789012345678901234567890123456")
; (print "the quick brown fox jumpped over the lazy dogs")
; (print (strrepl 2 "e" "the quick brown fox jumpped over the lazy dogs" "eht"))
; (print (strbfr 2 "e" "the quick brown fox jumpped over the lazy dogs"))
; (print (straft 2 "e" "the quick brown fox jumpped over the lazy dogs"))
; (exit)
