/* xlbind - xlisp symbol binding routines */
#include "xlset.h"
#include "xlisp.h"
#include "xldmem.h"

NODE *xlenv;

/* xlunbind - unbind symbols bound in this environment */
void xlunbind(env)
NODE *env;
{
	NODE *bnd;

	/* unbind each symbol in the environment chain */
	for (; xlenv != env; xlenv = xlenv->n_listnext) {
		bnd = xlenv->n_listvalue;
		bnd->n_bndsym->n_symvalue = bnd->n_bndvalue;
	}
}

/* xlbind - bind a symbol to a value */
void xlbind(sym, val)
NODE *sym;
NODE *val;
{
	NODE *lptr, *bptr;

	/* create a new environment list entry */
	lptr = newnode(LIST);
	lptr->n_listnext = xlenv;
	xlenv = lptr;

	/* create a new variable binding */
	lptr->n_listvalue = bptr = newnode(LIST);
	bptr->n_bndsym = sym;
	bptr->n_bndvalue = val;
}

/* xlfixbindings - make a new set of bindings visible */
void xlfixbindings(env)
NODE *env;
{
	NODE *eptr, *bnd, *sym, *oldvalue;

	/* fix the bound value of each symbol in the environment chain */
	for (eptr = xlenv; eptr != env; eptr = eptr->n_listnext) {
		bnd = eptr->n_listvalue;
		sym = bnd->n_bndsym;
		oldvalue = sym->n_symvalue;
		sym->n_symvalue = bnd->n_bndvalue;
		bnd->n_bndvalue = oldvalue;
	}
}
