/* xlisp - a small subset of lisp */
#include "xlset.h"
#include "xlisp.h"
#include "xleval.h"
#include "xlinit.h"
#include "xlprin.h"
#include "xlread.h"
#include "xlbind.h"


/* for libc6 */
#ifdef NEED_UNISTD
#include <unistd.h>
#endif

/* global variables */
jmp_buf *xljmpbuf;
jmp_buf topjmpbuf;

/* main - the main routine */
int main(argc, argv)
int argc;
char *argv[];
{
	NODE expr;
	int i;

	/* print the banner line */
	printf("XLISP version 1.2ajk\n");

	/* setup the error handler context buffer */
	xljmpbuf = (jmp_buf *)&topjmpbuf; /* was xljmpbuf = topjmpbuf; */

	/* setup initialization error handler */
	if (setjmp(*xljmpbuf)) { /* was if (setjmp(xljmpbuf)) { */
		printf("fatal initialization error\n");
		exit(1);
	}

	/* initialize xlisp */
	xlinit();

	/* load "init.lsp" */
	if (setjmp(*xljmpbuf) == 0) xlload("init"); /* was if (setjmp(xljmpbuf) == 0) xlload("init");  */

	/* load any files mentioned on the command line */
	if (setjmp(*xljmpbuf) == 0) { /* was if (setjmp(xljmpbuf) == 0) { */
		for (i = 1; i < argc; i++) {
			printf("[ loading \"%s\" ]\n", argv[i]);
			if (!xlload(argv[i])) xlfail("can't load file");
		}
	}
	
	/* main command processing loop */
	for (;;) {

		/* setup the error return */
		setjmp(*xljmpbuf); /* was setjmp(xljmpbuf); */

		/* free any previous expression and leftover context */
		xlstack = xlenv = NULL;

		/* create a new stack frame */
		xlsave(&expr, NULL);

		/* read an expression */
		if (!xlread(s_stdin->n_symvalue, &expr.n_ptr)) break;

		/* evaluate the expression */
		expr.n_ptr = xleval(expr.n_ptr);

		/* print it */
		xlprint(s_stdout->n_symvalue, expr.n_ptr, TRUE);
		xlterpri(s_stdout->n_symvalue);
	}
	return(0);
}
